{22 Feb 1998. This component is based upon T_BiancoIcon by Marco Bianchini. There were memory 
leaks in his component which I reported to Marco but received no reply from him. Apparently he is
serving in the Italian Army and has bigger fish to fry. ;-) So I have rewritten his component and
fixed the bugs that I knew about. This is freeware but copyrighted by me, Copyright 1998 by William
H. Sparhawk, wsparhawk@sprintmail.com, Oh, BTW, I do not accept any responsibility for any 
damage caused by this component, real or imagined.}

unit TIconHawk;

Interface

Uses
  SysUtils,Windows,Messages,Classes,Graphics,Controls,
  Forms,Dialogs,StdCtrls, ShellApi;
Type
  THawkDoIcons = Class(TComponent)
Private
    FFileName  : String;
    FNumberOfIcons : Integer;
    FIconIndex     : Integer;
    Procedure Find_Icon;

    Procedure SetFileName(Value:String);
    Procedure SetNumberOfIcons(Value:Integer);
    Procedure SetIconIndex(Value:Integer);
Protected
Public
  Icon : TIcon;
  Constructor Create(AOwner:TComponent); override;
  Destructor Destroy; override;
Published
  Property FileName : String Read FFileName Write SetFileName;
  Property NumberOfIcons : Integer Read FNumberOfIcons Write SetNumberOfIcons;
  Property IconIndex     : Integer Read FIconIndex Write SetIconIndex;
  Property Name;
  Property Tag;
end;

Procedure Register;

Implementation

Procedure Register;
Begin
  RegisterComponents('Sparhawk', [THawkDoIcons]);
End;

Constructor THawkDoIcons.Create(AOwner:TComponent);
Begin
  Inherited Create(AOwner);
  Icon := TIcon.Create;
End;

Destructor THawkDoIcons.Destroy;
Begin
  Inherited Destroy;
Icon.Free;

End;

Procedure THawkDoIcons.SetFileName(Value:String);
Begin
  If FFileName <> Value Then
   Begin
    FNumberOfIcons := 0;
    FFileName := Value;
    If FileExists(FFileName) Then
     FNumberOfIcons := ExtractIcon(Hinstance,Pchar(FFileName),-1);
      FIconIndex := 0;
       Find_Icon;
 end;
end;

Procedure THawkDoIcons.SetNumberOfIcons(Value:Integer);
Begin
  If FNumberOfIcons <> Value Then
   Begin
    FNumberOfIcons := Value;
    Find_Icon;
 end;
end;

Procedure THawkDoIcons.SetIconIndex(Value:Integer);
Begin
 If FIconIndex <> Value Then
  Begin
   FIconIndex := Value;
   Find_Icon;
 end;
end;

Procedure THawkDoIcons.Find_Icon;
Begin
 If FileExists(FFileName) Then
  Icon.Handle := ExtractIcon(Hinstance,Pchar(FFileName),FIconIndex);
end;
end.




  

















